//C6713dskinit.c Includes functions from TI in the C6713 CSL and C6713DSK BSL

#include "C6713dskinit.h"
#define using_bios;

Uint32 fs=DSK6713_AIC23_FREQ_8KHZ;
//Uint32 fs=DSK6713_AIC23_FREQ_16KHZ;
//Uint32 fs=DSK6713_AIC23_FREQ_24KHZ;
//Uint32 fs=DSK6713_AIC23_FREQ_32KHZ;
//Uint32 fs=DSK6713_AIC23_FREQ_44KHZ;
//Uint32 fs=DSK6713_AIC23_FREQ_48KHZ;
//Uint32 fs=DSK6713_AIC23_FREQ_96KHZ;

union {Uint32 combo; short channel[2];} AIC23_data;


//#define using_bios                  //if BIOS don't use top of vector table
extern Uint32 fs;            			//for sampling frequency

void c6713_dsk_init()       			//dsp-peripheral initialization
{
DSK6713_init();                   	//call BSL to init DSK-EMIF,PLL)

hAIC23_handle=DSK6713_AIC23_openCodec(0, &config);//handle(pointer) to codec
DSK6713_AIC23_setFreq(hAIC23_handle, fs);  //set sample rate
MCBSP_config(DSK6713_AIC23_DATAHANDLE,&AIC23CfgData);//interface 32 bits toAIC23

MCBSP_start(DSK6713_AIC23_DATAHANDLE, MCBSP_XMIT_START | MCBSP_RCV_START |
	MCBSP_SRGR_START | MCBSP_SRGR_FRAMESYNC, 220);//start data channel again
}

void comm_poll()					 		//added for communication/init using polling
{
	poll=1;              				//1 if using polling
   c6713_dsk_init();    				//init DSP and codec
}

void comm_intr()						 	//for communication/init using interrupt
{
	poll=0;                        	//0 since not polling
   IRQ_globalDisable();           	//disable interrupts
	c6713_dsk_init(); 					//init DSP and codec
	CODECEventId=MCBSP_getXmtEventId(DSK6713_AIC23_codecdatahandle);//McBSP1 Xmit

#ifndef using_bios						//do not need to point to vector table
  	IRQ_setVecs(vectors);     			//point to the IRQ vector table
#endif										//since interrupt vector handles this

  	IRQ_map(CODECEventId, 11);			//map McBSP1 Xmit to INT11
  	IRQ_reset(CODECEventId);    		//reset codec INT 11
   IRQ_globalEnable();       			//globally enable interrupts
  	IRQ_nmiEnable();          			//enable NMI interrupt
   IRQ_enable(CODECEventId);			//enable CODEC eventXmit INT11

	output_sample(0);        			//start McBSP interrupt outputting a sample
}

void output_sample(int out_data)    //for out to Left and Right channels
{
	short CHANNEL_data;

	AIC_data.uint=0;                 //clear data structure
	AIC_data.uint=out_data;          //32-bit data -->data structure

//The existing interface defaults to right channel. To default instead to the
//left channel and use output_sample(short), left and right channels are swapped
//In main source program use LEFT 0 and RIGHT 1 (opposite of what is used here)
	CHANNEL_data=AIC_data.channel[RIGHT]; 			//swap left and right channels
	AIC_data.channel[RIGHT]=AIC_data.channel[LEFT];
	AIC_data.channel[LEFT]=CHANNEL_data;
   if (poll) while(!MCBSP_xrdy(DSK6713_AIC23_DATAHANDLE));//if ready to transmit
		MCBSP_write(DSK6713_AIC23_DATAHANDLE,AIC_data.uint);//write/output data
}

void output_left_sample(short out_data)     	  	 //for output from left channel
{
	AIC_data.uint=0;                              //clear data structure
	AIC_data.channel[LEFT]=out_data;   //data from Left channel -->data structure

	if (poll) while(!MCBSP_xrdy(DSK6713_AIC23_DATAHANDLE));//if ready to transmit
		MCBSP_write(DSK6713_AIC23_DATAHANDLE,AIC_data.uint);//output left channel
}

void output_right_sample(short out_data)  		//for output from right channel
{
	AIC_data.uint=0;                             //clear data structure
	AIC_data.channel[RIGHT]=out_data; //data from Right channel -->data structure

	if (poll) while(!MCBSP_xrdy(DSK6713_AIC23_DATAHANDLE));//if ready to transmit
		MCBSP_write(DSK6713_AIC23_DATAHANDLE,AIC_data.uint);//output right channel
}

Uint32 input_sample()                      	  	//for 32-bit input
{
	short CHANNEL_data;

	if (poll) while(!MCBSP_rrdy(DSK6713_AIC23_DATAHANDLE));//if ready to receive
		 AIC_data.uint=MCBSP_read(DSK6713_AIC23_DATAHANDLE);//read data

//Swapping left and right channels (see comments in output_sample())
	CHANNEL_data=AIC_data.channel[RIGHT]; 			//swap left and right channel
	AIC_data.channel[RIGHT]=AIC_data.channel[LEFT];
	AIC_data.channel[LEFT]=CHANNEL_data;

	return(AIC_data.uint);
}

short input_left_sample()                   		//input to left channel
{
	if (poll) while(!MCBSP_rrdy(DSK6713_AIC23_DATAHANDLE));//if ready to receive
	 AIC_data.uint=MCBSP_read(DSK6713_AIC23_DATAHANDLE);//read into left channel
	return(AIC_data.channel[LEFT]);					//return left channel data
}

short input_right_sample()                  		//input to right channel
{
	if (poll) while(!MCBSP_rrdy(DSK6713_AIC23_DATAHANDLE));//if ready to receive
	 AIC_data.uint=MCBSP_read(DSK6713_AIC23_DATAHANDLE);//read into right channel
	return(AIC_data.channel[RIGHT]); 				//return right channel data
}

// DSP coefficients, variables, and constants
// Section 9.6.4
/*float b[5]={0.0201, 0.00, -0.0402, 0.00, 0.0201};*/
/*float a[5]={1.00, -2.1192, 2.6952, -1.6924, 0.6414}; */
/* Direct form II realization: scale factors: S=32, A=4, B=1  see Section 9.5*/
short b[5]={0x0293, 0x0000, 0xFADB, 0x0000, 0x0293}; //numerator in Q-15
short a[5]={0x2000, 0x43D0, 0xA9C1, 0x3628, 0xEB7A};// denominator in Q-15
/* note that a= -a (original) */
int w[5]={0, 0, 0, 0, 0}; // state variable

interrupt void c_int11()
{
   int lc;
   int rc;
   int lcnew;
   int rcnew;
   int i, sum=0;
   int sample;
//Left channel and right channel are switched
//  if a stereo cable is used,
//  tip=right channel; midddle ring=left channel
//  sleeve (bottom)=gounrd; 
	AIC23_data.combo=input_sample();
	lc=(float) (AIC23_data.channel[LEFT]);
	rc= (float) (AIC23_data.channel[RIGHT]);
	// Insert DSP algorithm bellow 
   rcnew=rc; // remove warning
   sample = (int) lc; /* input sample from the left cahnnel */
   sample = (sample << 16);  /* move to high 16 bits */
   sample = (sample>>5); /* scaled by 32 to avoid overflow */
   for (i=4;i>0;i--)
   {
     w[i]=w[i-1];
   }
   sum= (sample >> 2); /* scaled by 4 to use Q-15 */
   for (i=1;i<5;i++)
   {
     sum += (_mpyhl(w[i],a[i])) <<1;
   }
   sum = (sum <<2); /* scaled up by 4 */
   w[0]=sum;
   sum =0;
   for(i=0;i<5;i++)
   { 
     sum += (_mpyhl(w[i],b[i]))<<1;
   }
   sum = (sum << 5);  /* scaled up by 32 */
   sample= (sum>>16); /* move to low 16 bits */  
   lcnew=sample;
   rcnew=sample;
	//
	AIC23_data.channel[LEFT]=(short) lcnew;
    AIC23_data.channel[RIGHT]=(short) rcnew;
	output_sample(AIC23_data.combo);
}



void main()
{
  	comm_intr();
	while(1);
}






